/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_LEFTLINE_H
#define DPC_IMPL_TYPE_LEFTLINE_H

#include "impl_type_uint32.h"
#include "dpc/impl_type_array_rmegolftlnegeometry_6.h"
#include "impl_type_uint8.h"
#include "impl_type_boolean.h"

namespace dpc {
struct LeftLine {
    ::UInt32 rm_egolftlne_id{ 0U };
    ::dpc::array_RMEgoLftLnegeometry_6 rm_egolftlne_geometry{};
    ::UInt8 rm_egolftlne_color{ 0U };
    ::UInt8 rm_egolftlne_type{ 0U };
    ::Boolean rm_egolftlne_edoutview{ false };
    ::UInt8 rm_lftlnesnsrsource{ 0U };

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(rm_egolftlne_id);
        fun(rm_egolftlne_geometry);
        fun(rm_egolftlne_color);
        fun(rm_egolftlne_type);
        fun(rm_egolftlne_edoutview);
        fun(rm_lftlnesnsrsource);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(rm_egolftlne_id);
        fun(rm_egolftlne_geometry);
        fun(rm_egolftlne_color);
        fun(rm_egolftlne_type);
        fun(rm_egolftlne_edoutview);
        fun(rm_lftlnesnsrsource);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("rm_egolftlne_id", rm_egolftlne_id);
        fun("rm_egolftlne_geometry", rm_egolftlne_geometry);
        fun("rm_egolftlne_color", rm_egolftlne_color);
        fun("rm_egolftlne_type", rm_egolftlne_type);
        fun("rm_egolftlne_edoutview", rm_egolftlne_edoutview);
        fun("rm_lftlnesnsrsource", rm_lftlnesnsrsource);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("rm_egolftlne_id", rm_egolftlne_id);
        fun("rm_egolftlne_geometry", rm_egolftlne_geometry);
        fun("rm_egolftlne_color", rm_egolftlne_color);
        fun("rm_egolftlne_type", rm_egolftlne_type);
        fun("rm_egolftlne_edoutview", rm_egolftlne_edoutview);
        fun("rm_lftlnesnsrsource", rm_lftlnesnsrsource);
    }

    friend bool operator==(const ::dpc::LeftLine& lhs, const ::dpc::LeftLine& rhs) noexcept
    {
        return (lhs.rm_egolftlne_id == rhs.rm_egolftlne_id) && (lhs.rm_egolftlne_geometry == rhs.rm_egolftlne_geometry) && (lhs.rm_egolftlne_color == rhs.rm_egolftlne_color) && (lhs.rm_egolftlne_type == rhs.rm_egolftlne_type) && (lhs.rm_egolftlne_edoutview == rhs.rm_egolftlne_edoutview) && (lhs.rm_lftlnesnsrsource == rhs.rm_lftlnesnsrsource);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_LEFTLINE_H
